***************************
* SISTEMA CONTABLE HYMPLUS *
*

/*
  Programa para: Manejar la visulizacion de un reporte utilizando impresoras de matriz.
  Basado en    : RPREVIEW.PRG de Ingnacio Ortiza Zuiga.
  Modicado por : Paco Soriano  (Octubre de 1999)
*/
#include "FiveWin.ch"

#define GO_UP       1
#define GO_DOWN     2
#define GO_LEFT     1
#define GO_RIGHT    2
#define GO_PAGE    .T.

#define TXT_PREVIEW                              LoadString( GetResources(), 03 )
#define TXT_FIRST                                LoadString( GetResources(), 07 )
#define TXT_PREVIOUS                             LoadString( GetResources(), 08 )
#define TXT_NEXT                                 LoadString( GetResources(), 09 )
#define TXT_LAST                                 LoadString( GetResources(), 10 )
#define TXT_PRINT                                LoadString( GetResources(), 15 )
#define TXT_EXIT                                 LoadString( GetResources(), 16 )
#define TXT_FILE                                 LoadString( GetResources(), 17 )
#define TXT_PAGE                                 LoadString( GetResources(), 18 )
#define TXT_PAGENUM                              LoadString( GetResources(), 19 )
#define TXT_A_WINDOW_PREVIEW_IS_ALLREADY_RUNNING LoadString( GetResources(), 20 )
#define TXT_GOTO_FIRST_PAGE                      LoadString( GetResources(), 21 )
#define TXT_GOTO_PREVIOUS_PAGE                   LoadString( GetResources(), 22 )
#define TXT_GOTO_NEXT_PAGE                       LoadString( GetResources(), 23 )
#define TXT_GOTO_LAST_PAGE                       LoadString( GetResources(), 24 )
#define TXT_PREVIEW_ON_TWO_PAGES                 LoadString( GetResources(), 27 )
#define TXT_PREVIEW_ON_ONE_PAGE                  LoadString( GetResources(), 28 )
#define TXT_PRINT_CURRENT_PAGE                   LoadString( GetResources(), 29 )
#define TXT_EXIT_PREVIEW                         LoadString( GetResources(), 30 )
#define TXT_MATRIZ                               LoadString( GetResources(), 31 )
#define TXT_PRINT_MAT_CURRENT_PAGE               LoadString( GetResources(), 32 )

STATIC oBrush, oIcon, oBar, oFont, oCursor, oMeta1, oMeta2
*STATIC snPag
STATIC snPacohDC

//----------------------------------------------------------------------------//

FUNCTION MPreview(fcFileTxt,fcReporte)

****LOCAL hOldRes := GetResources()
LOCAL oSay
LOCAL aWindows
LOCAL nFor
LOCAL fcPagina, oFontT
LOCAL flSigue := .t.
LOCAL fcFile

/*
IF oWnd != NIL
  MsgStop(TXT_A_WINDOW_PREVIEW_IS_ALLREADY_RUNNING)
  RETU NIL
ENDIF
*/

* SET RESOURCES TO "PREVIEW.DLL"

aWindows := GetAllWin()

FOR nFor := 1 TO nWindows()
  IF Valtype(aWindows[nFor]) == "O"
    IF aWindows[nFor]:hWnd == GetWndApp()
      oIcon := aWindows[nFor]:oIcon
      EXIT
    ENDIF
  ENDIF
NEXT

DEFINE FONT oFont  NAME "Ms Sans Serif" SIZE 0,-12
DEFINE FONT oFontT NAME "Courier New"   SIZE 0,-12
DEFINE CURSOR oCursor RESOURCE "Lupa"

BuildMenu()

DEFINE WINDOW Pub:oWnd FROM 0, 0 TO 24, 80 TITLE fcReporte MENU Pub:oMenu COLOR CLR_BLACK,CLR_LIGHTGRAY ICON oIcon

DEFINE BUTTONBAR oBar 3D SIZE 33, 33 OF Pub:oWnd

oBar:bRClicked := {|| NIL }


DEFINE BUTTON RESOURCE "INICIO" OF oBar NOBORDER         MESSAGE TXT_GOTO_FIRST_PAGE        ACTION TopPage();
              TOOLTIP Strtran(TXT_FIRST,"&","")
DEFINE BUTTON RESOURCE "ANTERIOR" OF oBar NOBORDER       MESSAGE TXT_GOTO_PREVIOUS_PAGE     ACTION PrevPage();
              TOOLTIP Strtran(TXT_PREVIOUS,"&","")
DEFINE BUTTON RESOURCE "SIGUIENTE" OF oBar  NOBORDER     MESSAGE TXT_GOTO_NEXT_PAGE         ACTION NextPage();
              TOOLTIP Strtran(TXT_NEXT,"&","")
DEFINE BUTTON RESOURCE "FINAL" OF oBar NOBORDER          MESSAGE TXT_GOTO_LAST_PAGE         ACTION BottomPage();
              TOOLTIP Strtran(TXT_LAST,"&","")
DEFINE BUTTON RESOURCE "IMPRIMIR" OF oBar GROUP NOBORDER MESSAGE TXT_PRINT_MAT_CURRENT_PAGE ACTION PrintPage();
              TOOLTIP Strtran(TXT_MATRIZ,"&","")

DEFINE BUTTON RESOURCE "SALIDA" OF oBar GROUP NOBORDER   MESSAGE TXT_EXIT_PREVIEW           ACTION Pub:oWnd:End();
              TOOLTIP Strtran(TXT_EXIT,"&","")

@ 9, 420 SAY Pub:oPage PROMPT TXT_PAGENUM+ltrim(str(1,4)) SIZE 160, 15 PIXEL OF oBar FONT oFont

fcFile:=RLoadText(fcFileTxt)

*Pub:oWnd:bGotFocus  := {|| SetResources("Preview.dll")}  //ORIGNAL
*Pub:oWnd:bLostFocus := {| hWndGetFocus | If( Pub:oWnd != nil .and. GetParent( hWndGetFocus ) != Pub:oWnd:hWnd,;
*                          SetResources( hOldRes ),) } //ORIGINAL

Pub:oWnd:bLostFocus := {| hWndGetFocus | If( Pub:oWnd != nil .and. GetParent( hWndGetFocus ) != Pub:oWnd:hWnd,,) }


WndCenter(Pub:oWnd:hWnd)

***ACTIVATE WINDOW Pub:oWnd MAXIMIZED ON INIT RCambia(oFontT,Pub:oPage) VALID (RExit(fcFile),SetResources(hOldRes),;
*                         Pub:oWnd:=NIL,.t.) //ORGINAL

ACTIVATE WINDOW Pub:oWnd MAXIMIZED ON INIT RCambia(oFontT,Pub:oPage) VALID (RExit(fcFile),,Pub:oWnd:=NIL,.t.)

Return (NIL)

//----------------------------------------------------------------------------//

STATIC FUNCTION RExit(fcFile)

wfPrueba->(DBCLOSEAREA())

FERASE(fcFile+".DBF")
RETURN (.t.)

STATIC FUNCTION BuildMenu()

LOCAL nFor

MENU Pub:oMenu
  MENUITEM TXT_FILE
  MENU
    MENUITEM TXT_MATRIZ   ACTION PrintPage()    MESSAGE TXT_PRINT_MAT_CURRENT_PAGE
    SEPARATOR
    MENUITEM TXT_EXIT     ACTION Pub:oWnd:End() MESSAGE TXT_EXIT_PREVIEW
  ENDMENU
  MENUITEM TXT_PAGE
  MENU
    MENUITEM TXT_FIRST    ACTION TopPage()      MESSAGE TXT_GOTO_FIRST_PAGE
    MENUITEM TXT_PREVIOUS ACTION PrevPage()     MESSAGE TXT_GOTO_PREVIOUS_PAGE
    MENUITEM TXT_NEXT     ACTION NextPage()     MESSAGE TXT_GOTO_NEXT_PAGE
    MENUITEM TXT_LAST     ACTION BottomPage()   MESSAGE TXT_GOTO_LAST_PAGE
  ENDMENU
ENDMENU

return NIL

STATIC FUNCTION NextPage()

LOCAL x

x := Len(aPags)
Pub:snPag++
IF Pub:snPag > x
  Pub:snPag := x
ENDIF

RLoadPage(aPags[Pub:snPag,2],aPags[Pub:snPag,3])
Pub:oPage:SetText(OemToAnsi("Pgina...")+ltrim(str(Pub:snPag,4))+"/"+ltrim(str(Len(aPags),4)))

RETURN NIL

//----------------------------------------------------------------------------//

STATIC Function PrevPage()
 
Pub:snPag--
IF Pub:snPag < 1
  Pub:snPag := 1
ENDIF
RLoadPage(aPags[Pub:snPag,2],aPags[Pub:snPag,3])
Pub:oPage:SetText(OemToAnsi("Pgina...")+ltrim(str(Pub:snPag,4))+"/"+ltrim(str(Len(aPags),4)))

RETURN NIL

//----------------------------------------------------------------------------//

STATIC Function TopPage()
 
RLoadPage(aPags[1,2],aPags[1,3])
Pub:snPag := 1
Pub:oPage:SetText(OemToAnsi("Pgina...")+ltrim(str(Pub:snPag,4))+"/"+ltrim(str(Len(aPags),4)))

RETURN NIL

//----------------------------------------------------------------------------//

STATIC Function BottomPage()

LOCAL x
x := LEN(aPags)
RLoadPage(aPags[x,2],aPags[x,3])
Pub:snPag := x
Pub:oPage:SetText(OemToAnsi("Pgina...")+ltrim(str(Pub:snPag,4))+"/"+ltrim(str(Len(aPags),4)))

RETURN NIL


STATIC FUNCTION PrintPrv(oDlg, nOption, oIni, oFin)

LOCAL nFor,oPrn,x, fnIP,fnFP, fcString, fnLin, flNewPage

CursorWait()

DO CASE
 CASE nOption == 1                     // All
  x := Len(aPags)
  fnIP := aPags[1,2]
  fnFP := aPags[x,3]
 CASE nOption == 2                     // Current page
  fnIP := aPags[Pub:snPag,2]
  fnFP := aPags[Pub:snPag,3]
 CASE nOption == 3                     // Range
  fnIP := aPags[RValor(oIni:cText()),2]
  fnFP := aPags[RValor(oFin:cText()),3]
ENDCASE

oPrn := TDosPrn():New("lpt1")
oPrn:StartPage()
wfPrueba->(DBGOTO(fnIP))
fnLin := 1
WHILE wfPrueba->(RECNO()) >= fnIP .and. wfPrueba->(RECNO()) <= fnFP .and. .not. wfPrueba->(eof())
  fcString := wfPrueba->CADENA
  fcString := STRTRAN(fcString,CHR(18)," ")
  IF CHR(12) $ fcString
    flNewPage := .t.
   ELSE
    flNewpage := .f.
  ENDIF
  fcString := STRTRAN(fcString,CHR(12)," ")
  fcString := RTRIM(fcString)
  IF LEFT(fcString,1) = CHR(15)
    oPrn:SayCmp(fnLin,0,SUBSTR(fcString,2))
   ELSE
    oPrn:Say(fnLin,0,SUBSTR(fcString,2))
  ENDIF
  IF flNewPage
    fnLin := 1
    oPrn:EndPage()
    oPrn:StartPage()
   ELSE
    fnLin++
  ENDIF
  wfPrueba->(DBSKIP())           /*     Salta al siguiente registro   */
END
oPrn:End()
CursorArrow()

IF oDlg != NIL
  oDlg:End()
ENDIF


RETURN NIL

STATIC FUNCTION RNumPagyReg()

LOCAL fnIP,fnFP,fnP

fnP   := 1
aPags := {}   /*  es un arreglo*/
wfPrueba->(DBGOTOP())            /*     Va al primer registros       */
fnIP := wfPrueba->(RECNO())      /*  Me dice en que registro estas   */

while .not. wfPrueba->(eof())
  if CHR(12) $ wfPrueba->CADENA
    fnFP := wfPrueba->(RECNO())
    aadd(aPags,{fnP,fnIP,fnFP})
    fnP++                         /*     Incrementa 1 a fnP           */
    fnIP:=fnFP + 1                /*   para operaciones */
  endif
  wfPrueba->(DBSKIP())            /*     Salta al siguiente registro   */
end
Pub:snPag := 1

RETURN NIL

STATIC Function RLoadPage(fnIP,fnFP)

LOCAL fcPagina:=""
 wfPrueba->(DBGOTO(fnIP))
 while wfPrueba->(RECNO()) >= fnIP .and. wfPrueba->(RECNO()) <= fnFP .and. ;
  .not. wfPrueba->(eof())
  fcPagina := fcPagina + wfPrueba->CADENA + CRLF
  wfPrueba->(DBSKIP())           /*     Salta al siguiente registro   */
 end
 fcPagina:=STRTRAN(fcPagina,CHR(15),"")
 fcPagina:=STRTRAN(fcPagina,CHR(18),"")
 fcPagina:=STRTRAN(fcPagina,CHR(27),"")
 Pub:oPagina:cText(fcPagina)
RETURN NIL


STATIC Function PrintPage()

     LOCAL oFont,nLast,nFirst

*    LOCAL hOldRes := GetResources() //ORGINAL
     LOCAL oDlg, oRad, oPageIni, oPageFin

     LOCAL nOption := 1
     nFirst := 1
     nLast  := Len(aPags)

*    SET RESOURCES TO "Preview.dll" //ORIGINAL
     DEFINE FONT oFont NAME "ARIAL" SIZE 0,14

     DEFINE DIALOG oDlg RESOURCE "PRINTDOS" FONT oFont

     REDEFINE BUTTON ID 101 OF oDlg  ACTION PrintPrv(oDlg, nOption, oPageIni,oPageFin)
     REDEFINE BUTTON ID 102 OF oDlg ACTION oDlg:End()

     REDEFINE RADIO oRad VAR nOption ID 103,104,105 OF oDlg ON CHANGE;
                       iif(nOption==3,(oPageIni:Enable(),oPageFin:Enable()),;
                          (oPageIni:Disable(),oPageFin:Disable()) )

     REDEFINE GET oPageIni VAR nFirst ID 106  PICTURE "99999" OF oDlg
     REDEFINE GET oPageFin VAR nLast  ID 107  PICTURE "99999"  OF oDlg

     oPageIni:Disable()
     oPageFin:Disable()

*   SetResources(hOldRes ) //ORGINAL

     ACTIVATE DIALOG oDlg

RETURN NIL


STATIC FUNCTION RLoadText(fcFileTxt)

LOCAL fcFile
LOCAL aDbf:={}

aadd(aDBF, {"CADENA"      , "C" , 150 , 0 })
fcFile := RCreaTempo(aDbf)
DBSELECTAREA(8)
DBUSEAREA(.t.,, fcFile ,"wfPrueba", .f. )
DBSELECTAREA("wfPrueba")
APPEND FROM (fcFileTxt) SDF
COPY TO TRAB

RETURN(fcFile)

*STATIC FUNCTION RCambia(oFontT,(Pub:oPage))

STATIC FUNCTION RCambia(oFontT)          //Modificado mauricio

LOCAL fcPagina
  @ 36,1  GET Pub:oPagina VAR fcPagina OF Pub:oWnd TEXT ;
          SIZE Pub:oWnd:nRight-Pub:oWnd:nLeft-13,(Pub:oWnd:nBottom-Pub:oWnd:nTop)-85 ;
          FONT oFontT PIXEL HSCROLL READONLY
  RNumPagyReg()
  RLoadPage(aPags[1,2],aPags[1,3])
  Pub:oPage:SetText(OemToAnsi("Pgina...")+ltrim(str(Pub:snPag,4))+"/"+ltrim(str(Len(aPags),4)))
RETURN(.T.)


FUNCTION RCreaTempo(aDbf)
 LOCAL fcFile
 while .t.
  fcFile := RIGHT(STR(LOG(SECONDS()),15,12),8)
  if .not. file(fcFile+".DBF")  .and. .not. file(fcFile+".NTX")
   DBCREATE(fcFile,aDbf)
   exit
  endif
 enddo
RETURN(fcFile)

FUNCTION RFormatMat(aSizesCol)
 LOCAL i,j,fcCols,fnSpaces,fnChars := 0
 LOCAL aCols := {}
 LOCAL fcDummy,fnPI,fnPF
 j := LEN(aSizesCol)
 fcCols := ""
 for i := 1 to j
  fcCols := fcCols + STR(aSizesCol[i],3) + ","
  fnChars := fnChars + aSizesCol[i]
 next i
 if fnChars < 132
  fnSpaces := INT((132 - fnChars) / (j - 1))
  fnPI := 1
  for i := 1 to j
   fnPF := fnPI + (aSizesCol[i] - 1)
   aadd(aCols,{fnPI,fnPF})
   fnPI := fnPF + fnSpaces + 1
  next i
 else
  fnSpaces := 2
  fnPI := 1
  for i := 1 to j
   fnPF := fnPI + (aSizesCol[i] - 1)
   aadd(aCols,{fnPI,fnPF})
   fnPI := fnPF + fnSpaces + 1
  next i
 endif
RETURN(aCols)

FUNCTION RCreaTxt()
 LOCAL fcFile
 while .t.
  fcFile := RIGHT(STR(LOG(SECONDS()),15,12),8)+".TXT"
  if .not. file(fcFile)
   exit
  endif
 enddo
RETURN(fcFile)

FUNCTION RMakeString(aData,aCols)
 LOCAL fcString ,fcData
 LOCAL i,j,x
 j := LEN(aData)
 fcString := SPACE(aCols[j,2])
 for i := 1 to j
  x := aCols[i,2] - aCols[i,1] + 1
  if aData[i,2]
   fcData := aData[i,1]
   if len(fcData) < x
    fcData := PADL(fcData,x," ")
   else
    fcData := RIGHT(fcData,x)
   endif
  else
   fcData := aData[i,1]
   if len(fcData) > x
    fcData := LEFT(aData[i,1],x)
   else
    fcData := PADR(fcData,x," ")
   endif
  endif
  fcString := LEFT(fcString,aCols[i,1]-1) + fcData + ;
              RIGHT(fcString,aCols[j,2]-aCols[i,2])
 next i
RETURN(fcString)

FUNCTION RCenter(oPrn,fnLin,fcString,y)
 fcString := PADC(fcString,y," ")
 oPrn:SayCmp(fnLin,0,fcString )
 fnLin++
RETURN(fnLin)

FUNCTION RRight(oPrn,fnLin,fcString,y)
 fcString := PADL(fcString,y," ")
 oPrn:SayCmp(fnLin,0,fcString )
 fnLin++
RETURN(fnLin)

FUNCTION RValor(fcCadena)
 LOCAL fnNumero,i,j,flMinus := .f.
 j:=len(fcCadena)
 fnNumero := space(0)
 for i := 1 to j
  if SUBSTR(fcCadena,i,1)$"0123456789."
   fnNumero := fnNumero + SUBSTR(fcCadena,i,1)
  else
   if SUBSTR(fcCadena,i,1)$"-"
    flMinus := .t.
   endif
  endif
 next i
 fnNumero := VAL(fnNumero)
 if flMinus
  fnNumero := fnNumero * -1
 endif
RETURN(fnNumero)
