//ͻ
// Program......: tRepDos                                                 
// Date.........: 29/04/2002                                              
// Author.......: Carlos A. Sincuir Romero                                
//ͼ

// Clase TRepDos

#include "FiveWin.ch"

#ifdef __XPP__
   #include "Class.ch"
   #include "types.ch"
   #define New  _New
#endif

//----------------------------------------------------------------------------//

CLASS TRepDos

   DATA   nPage , nHa, nFa, nCols, nLin
   DATA   lPreview, lCondensed
   DATA   aHeader, aFooter, aColumns
   DATA   cPort, cFile, cCaption, cFileTxt
   DATA   oPrn
   DATA   bWhile, bFor, bSkip

   METHOD New( aHea,  aFoo, lPrev, lCond, cPor, cFil, cCap, cHa, cFa ) CONSTRUCTOR
   METHOD Activate()
   METHOD RptDosAddCol( aTit, aDat, nTam, cPic, lTot, cAli )
   METHOD Header()
   METHOD AddLine( nLines )
   METHOD Say( cTxt )

ENDCLASS

//**********************************************************************************
METHOD New( aHea,  aFoo, lPrev, lCond, cPor, cFil, cCap, cHa, cFa, bWh, bFo ) CLASS TRepDos
LOCAL i, j

   #ifdef __XPP__
      #undef New
   #endif

   DEFAULT aHea       := {}          ,;
           aFoo       := {}          ,;
           cPor       := "LPT1"      ,;
           lPrev      := .F.         ,;
           lCond      := .F.         ,;
           cCap       := ""          ,;
           cFil       := ""          ,;
           bWh        := {|| !eof() },;
           bFo        := {|| .T.    },;
           cHa        := "CENTER"   ,;
           cFa        := "CENTER"

   ::aHeader      := aHea
   ::aFooter      := aFoo
   ::cPort        := cPor
   ::lPreview     := lPrev
   ::lCondensed   := lCond
   ::cCaption     := cCap
   ::nPage        := 0
   ::bSkip        := ""

   ::aColumns     := Array( 50,10 )
   ::nCols        := 0
   ::nLin         := 0

   ::bWhile       := bWh
   ::bFor         := bFo

   DO CASE
   CASE cHa == "LEFT"
        ::nHa := 0
   CASE cHa == "RIGHT"
        ::nHa := 1
   OTHERWISE
        ::nHa := 2
   ENDCASE

   DO CASE
   CASE cFa == "LEFT"
        ::nFa := 0
   CASE cFa == "RIGHT"
        ::nFa := 1
   OTHERWISE
        ::nFa := 2
   ENDCASE

RETURN SELF

//*****************************
METHOD RptDosAddCol( aTit, aDat, nTam, bPic, lTot, cCAli, cDAli  ) CLASS TRepDos

 DEFAULT aTit := {"Column"+Str( ::nCols +1, 2 )} ,;
         aDat := { "" }                          ,;
         nTam := 10                              ,;
         ltot := .T.                             ,;
        cCAli := "LEFT"

 ::nCols++
 ::aColumns[ ::nCols, 1 ] := aTit
 ::aColumns[ ::nCols, 2 ] := aDat
 ::aColumns[ ::nCols, 3 ] := nTam
 ::aColumns[ ::nCols, 4 ] := bPic
 ::aColumns[ ::nCols, 5 ] := lTot

 DO CASE
 CASE cCAli == "LEFT"
      ::aColumns[ ::nCols, 6 ] := 0
 CASE cCAli == "RIGHT"
      ::aColumns[ ::nCols, 6 ] := 1
 OTHERWISE
      ::aColumns[ ::nCols, 6 ] := 2
 ENDCASE
/*
 DO CASE
 CASE cFa == "LEFT"
      ::aColumns[ ::nCols, 6 ] := 0
 CASE cFa == "RIGHT"
      ::aColumns[ ::nCols, 6 ] := 1
 OTHERWISE
      ::aColumns[ ::nCols, 6 ] := 2
 ENDCASE
*/
 ::aColumns[ ::nCols, 7 ] := cDAli

RETURN NIL


///**********************************
METHOD ACTIVATE( bEnd ) CLASS TRepDos
LOCAL i, cLin, cCampo

DEFAULT bEnd := ""

   if ::lpreview
      ::cFileTxt := RCreaTxt()
      ::oPrn := TDosPrn():New(::cFileTxt)
   else
      ::oPrn := TDosPrn():New(::cPort)
   endif

   ::oPrn:StartPage()

   ::Header()

   DO WHILE eval(::bWhile)
      cLin := ""
      For i:=1 to ::nCols

/*
        DO CASE
        CASE ::aColumns[ i, 6 ] == 2
             cLin  += Padc( Eval( ::aColumns[i,1][1] ), ::aColumns[ i, 3] )
        CASE ::aColumns[ i, 6 ] == 1
             cLin  += Padl( Eval( ::aColumns[i,1][1] ), ::aColumns[ i, 3] )
        OTHERWISE
             cLin  += Padr( Eval( ::aColumns[i,1][1] ), ::aColumns[ i, 3] )
        ENDCASE
*/

        cCampo := Eval( ::aColumns[i,2][1] )
        If ValType( cCampo ) == "N"
           cCampo := Transform( cCampo, Eval( ::aColumns[ i, 4] ) )
        End
        cLin+= Left( cCampo, ::aColumns[ i, 3] )
        cLin += " "
      Next i

      If !::lCondensed
         ::oPrn:Say( ::nLin,0, Padc( cLin, 80 ) )
      Else
        ::oPrn:SayCmp( ::nLin,0, Padc( cLin, 137 ) )
      End

      ::nLin++
*     If ::nLin > 55
      If ::nLin > Pub:Tdoslineas
	 ::oPrn:EndPage()
         ::oPrn:StartPage()
         ::Header()
      End

      If Empty( ::bSkip )
         DbSkip()
      Else
         Eval( ::bSkip() )
      End

   ENDDO

   If !Empty( bEnd )
      EVAL( bEnd )
   End

   ::oPrn:EndPage()
   ::oPrn:End()

 /*   Aqui se manda a llamar el preview     */

 if ::lPreview
  MPreview(::cFileTxt,::cCaption)
  FERASE(::cFileTxt)
 endif

 CursorArrow()


Return NIL


///**********************************
METHOD Header() CLASS TRepDos

Local i,j, cLinp, cLin, aHea, aFoo

::nPage++
Pub:Pagina:=::nPage  //Toma el Numero de la PAgina
*msginfo(Pub:Pagina)

aHea:= {}
aFoo:= {}

For i:=1 to Len( ::aHeader )
    Aadd( aHea,Eval( ::aHeader[i] ) )
Next

/*
For i:=1 to Len( ::aFooter )
    Aadd( aFoo,Eval( ::aFooter[i] ) )
Next
*/

//*** NORMAL
If !::lCondensed

   For i:=1 to Len( ::aHeader )
       DO CASE
       CASE ::nHa == 2
            ::oPrn:Say( i,0, Padc( aHea[i], 80 ) )
       CASE ::nHa == 1
            ::oPrn:Say( i,0, Padl( aHea[i], 80 ) )
       OTHERWISE
            ::oPrn:Say( i,0, aHea[i] )
       ENDCASE
   Next i

   l    := i

   cLinp:= ""
   cLin := ""
   For i:=1 to ::nCols
       cLinp += Replicate("-", ::aColumns[ i, 3] )
       cLinp += " "

       DO CASE
       CASE ::aColumns[ i, 6 ] == 2
            cLin  += Padc( Eval( ::aColumns[i,1][1] ), ::aColumns[ i, 3] )
       CASE ::aColumns[ i, 6 ] == 1
            cLin  += Padl( Eval( ::aColumns[i,1][1] ), ::aColumns[ i, 3] )
       OTHERWISE
            cLin  += Padr( Eval( ::aColumns[i,1][1] ), ::aColumns[ i, 3] )
       ENDCASE
       cLin += " "
   Next i

   ::oPrn:Say( l,0, Padc( cLinp, 80 ) )
   l++
   ::oPrn:Say( l,0, Padc( cLin, 80 ) )
   l++
   ::oPrn:Say( l,0, Padc( cLinp, 80 ) )


///*** COMPRIMIDO
ELSE

   For i:=1 to Len( ::aHeader )
       DO CASE
       CASE ::nHa == 2
            ::oPrn:SayCmp( i,0, Padc( aHea[i], 137 ) )
       CASE ::nHa == 1       
            ::oPrn:SayCmp( i,0, Padl( aHea[i], 137 ) )
       OTHERWISE
            ::oPrn:SayCmp( i,0, aHea[i] )
       ENDCASE
   Next i

   l    := i
   cLinp:= ""
   cLin := ""
   For i:=1 to ::nCols
       cLinp += Replicate("-", ::aColumns[ i, 3] )
       cLinp += " "
       
       DO CASE
       CASE ::aColumns[ i, 6 ] == 2
            cLin  += Padc( Eval( ::aColumns[i,1][1] ), ::aColumns[ i, 3] )
       CASE ::aColumns[ i, 6 ] == 1
            cLin  += Padl( Eval( ::aColumns[i,1][1] ), ::aColumns[ i, 3] )
       OTHERWISE
            cLin  += Padr( Eval( ::aColumns[i,1][1] ), ::aColumns[ i, 3] )
       ENDCASE
       cLin += " "
   Next i

   ::oPrn:SayCmp( l,0, Padc( cLinp, 137 ) )
   l++
   ::oPrn:SayCmp( l,0, Padc( cLin, 137 ) )
   l++
   ::oPrn:SayCmp( l,0, Padc( cLinp, 137 ) )

ENDIF

::nLin := l+1

RETURN NIL


///**********************************
METHOD AddLine( nLines ) CLASS TRepDos

DEFAULT nLines := 1

::nLin += nLines

RETURN NIL


///**********************************
METHOD Say( cTxt ) CLASS TRepDos

DEFAULT cTxt := ""

If !::lCondensed
   ::oPrn:Say( ::nLin,0, Padc( cTxt, 80 ) )
Else
   ::oPrn:SayCmp( ::nLin,0, Padc( cTxt, 137 ) )
End

::nLin++

RETURN NIL


